<?php

$version = '1.0';

/**
 *
 * chartmaker.php
 *
 * Crea la classifica a partire da un database dei profili DimensioneX (.sav)
 *
 *
 * Versione: vedi sopra
 * Autore: Cristiano Leoni
 * Siti di riferimento:
 *	http://www.dimensionex.net
 *	http://www.sitiweb-bologna.com
 *
 * NOTA SU QUESTO SOFTWARE
 *
 * Licenza: GPL 2.0, Open Source, condividi liberamente
 * Nessuna garanzia, usa a tuo rischio
 *
 */

//** CONFIGURA QUI

$savfile = "../private/sottomondo.sav";	// Percorso assoluto o relativo al file dei profili .sav

// Settaggi per produrre la classifica

$cfg_stampa_profili=FALSE;	// Metti TRUE se vuoi vedere i dati sui profili (debug)
$cfg_stampa_riepilogo=FALSE;	// Metti TRUE se vuoi vedere il riepilogo (debug)

$cfg_maxelementi=10;		// Max elementi in classifica (default: 10)

$cfg_parametri=array(		// Parametri che vuoi vedere in classifica, in ordine di apparizione
	'Crediti','Salute','login');
$cfg_titoli=array(			// Titoli delle sezioni della classifica, rispettare l'ordine dato sopra
	'Crediti','Salute','Ultimo login');
$cfg_unitamisura=array(			// Unita di misura per ciascun parametro, rispettare l'ordine dato sopra
	'monete','punti-salute','');
$cfg_formattanumero=array(		// Formattare il valore di classifica? Se sono numeri mettere true. Rispettare l'ordine
	true,false,false);
	
$cfg_linkprofilo=''; // URL del profilo del giocatore, %nick% verra sostituito dal nick. Mettere stringa nulla se non serve
	//Per Sottomondo: 'http://www.sottomondo.org/infobox.php?id=%nick%'

// Settaggi per interpretare il file dei profili

$eccezioni = array( // Prefissi (PREF_resto) che sicuramente non fanno riferimento a profili di gioco. Nel dubbio lascia invariato
		'ctx',
		); 
$profileparts = array(	// Terminazioni di chiavi setting (xxx_TERMINAZ) che sicuramente fanno riferimento a profilo di gioco.  Nel dubbio lascia invariato
		'properties',
		'login',
		'cluster',
		'events',
		'fbid',
		'image',
		'items',
		'location',
		'name',
		'panel',
		'pass',
		'when',
		'worldInstanceId',
		'worldVersion',
		'worldId',
		);

//** BASTA CONFIGURARE!
 
// History
//
// 1.0 - Versione iniziale

$props = array();
$profiles=array();
$partscount=array();

out_header('Classifica');

if (file_exists($savfile) && $file = fopen($savfile,"r")) {

	$echo = '';

	while (!(feof($file))){
		$line = fgets($file);

		$count++;
		$matches=array();
		$x = preg_match("/^([^=]+)_([^=]*)=(.*)/", $line,$matches);

		// check
		if ($x && (!in_array($matches[1],$eccezioni))) { // Properties line found!
			//echo "$x<br/>$line<br>".print_r($matches,true),"<hr>\n";
			//exit;

			$nick=$matches[1];
			$left=$nick.'_'.$matches[2];
			$right=chop($matches[3]); 

			if (in_array($matches[2],$profileparts)) { // Profile part found
				if (!isset($profiles[$nick])) $profiles[$nick]=array();
				$profiles[$nick][$matches[2]]=$right;

				if (!isset($partscount[$matches[2]])) $partscount[$matches[2]]=0;
				$partscount[$matches[2]]=1+$partscount[$matches[2]];
			} else {
				$echo .= "<h2>Unknown part</h2>";
				$echo .= "<i>".$matches[2]."</i><br>\n";
				$echo .= "$x<br/>$line<br>".print_r($matches,true)."<hr>\n";
			}

		} else {
			$echo .= "<b>Saltata/non profilo</b>: $line<hr>";
			$skipped++;
		}

	}
	
} else {
	echo "Il file dei profili: $savfile non esiste.";
	exit(1);
}


	$echo .= "<h2>Profili trovati</h2>";
	$echo .= "<table border=\"1\" cellpadding=0 cellspacing=0 width=\"100%\">";
	ksort($profiles);
	
	foreach ($profiles as $user=>$parts) {
		$profcount++;

		if ($parts['properties'] && $parts['name'] && $parts['login']) {
			$buono=TRUE;
			$good++;
		} else {
			$buono=FALSE;
			$bad++;
		}
		
		if ($buono) {
			$echo .= "<tr><td>$user</td><td>";

			$props[$user]=array(); // Registriamo le proprietà di questo utente prese dai vari settaggi
			
			foreach ($parts as $p=>$v) {
				$echo .= "$p ";
				$props[$user][$p]=$v;
			}
			
			// Scompattiamo il settaggi properties che contiene punteggi e valori delle variabili settate nel gioco
			if ($props[$user]['properties']) {
				$setprops=array();
				uwt_explode2arr($props[$user]['properties'],$setprops);
				if (count($setprops)) { // Conversione riuscita
					unset($props[$user]['properties']);
					foreach ($setprops as $p=>$v) {
						$props[$user][$p]=$v;
						$echo .= "$p ";
					}
				}
			}
			
			$echo .= "</td></tr>\n";
		}
		
		
	}
	$echo .= "</table>";

	if ($cfg_stampa_profili) echo $echo;

	if ($cfg_stampa_riepilogo) { 
		echo "<h2>Riepilogo</h2>";
		echo "<dl>";
		echo "<dt>Profili totali</dt><dd>$profcount</dd>\n";	
		echo "<dt>Profili OK</dt><dd>$good</dd>\n";	
		echo "<dt>Profili non validi</dt><dd>$bad</dd>\n";	;
		echo "<dt>Linee saltate</dt><dd>$skipped</dd>\n";	
		echo "</dl>\n";
	}

	echo "<h2>Classifica</h2>";


	for ($i=0;$i<count($cfg_parametri);$i++) { // Ciclo su tutti i parametri previsti x la classifica
	
		$par = $cfg_parametri[$i]; // Parametro a cui si riferisce la sezione corrente

		// Trova tutti i valori per la sezione corrente
		
		$valori = array(); // Conterrà i valori per la sezione corrente
		foreach ($props as $user=>$setprops) {
			if ($setprops[$par]) $valori[$user]=$setprops[$par];
		}
		
		arsort($valori); // Ordina decrescente


		echo "<a name=\"$par\"><h3 class=\"bordosopra\">".$cfg_titoli[$i]."</h3></a>";


		echo "<ol>";
		$counter = 0;
		foreach ($valori as $nick=>$val) { // dal primo all'ultimo classificato per quersta sezione

			$name = uwt_javaUnicode_to_utf8($props[$nick]['name']); // Trova nome

			$v = $val;
			
			$url = $cfg_linkprofilo;
			if ($url) {
				$url=str_replace('%nick%',htmlspecialchars($nick),$url);
			}
			
			// Stampa dati
			
			echo "<li><b>";
			echo ($url?"<a rel=\"nofollow\" href=\"$url\">":'');
			echo $name;
			echo ($url?'</a>':'');
			echo '</b>: ';
			
			echo ($cfg_formattanumero[$i]?number_format($val, 0, ',','.'):$val).' ';
			
			echo $cfg_unitamisura[$i]."</li>\n";
	
			// Se sono già abbastanza risultati concludi sezione
			$counter++;
			if ($counter >= $cfg_maxelementi) break;
		}
		echo "</ol>";

	}

out_footer();


// FUNZIONI PERSONALIZZABILI

function out_header($title=NULL) {
	echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>';
if ($title) {
echo "<title>$title</title>";
}
echo '
<link rel="stylesheet" href="classifica.css" type="text/css" media="all" />
</head>
<body>';
}

function out_footer() {
	echo "</body>
</html>";
}


// FUNZIONI UTILITA

// Converts a DimnsioneX settings format''s set string into an assoc array
function uwt_toassoc_ic($setstring) {
	$arr = array();
	if (substr($setstring,0,7) != '\\!set\\!') {
		echo "toassoc() error - not a set: $setstring";
		exit;
	}
	$setstring = substr($setstring,7);
	//$setstring = str_replace('\\','',$setstring);
	$setstring = str_replace('*',',',$setstring);

	uwt_explode2arr_ic($setstring,$arr);

	return $arr;
}

function uwt_explode2arr($propstring,&$arr) {
	$arrprops = split(",",$propstring);

	foreach($arrprops as $v) {
		$left = null;
		$right = null;
		uwt_split_in_two($v,'\=',$left,$right);
		$arr[$left] = $right;
	}
}
function uwt_explode2arr_ic($propstring,&$arr) {
	$arrprops = split(",",$propstring);

	foreach($arrprops as $v) {
		$left = null;
		$right = null;
		uwt_split_in_two($v,'\=',$left,$right);
		if ($left!=null) {
			$arr[strtolower($left)] = $right;
		}
	}
}

function uwt_split_in_two($string,$sep,&$left,&$right) {
	$x=strpos($string,$sep);
	$left = substr($string,0,$x);
	$right = substr($string,$x+strlen($sep));
}


function uwt_javaUnicode_to_utf8($data) {
	$res = '';
	$cur = 0;

	if (!is_array($data)) {
		$data = uwt_stringtoarray($data);
	}

	while($cur < count($data)){
		$char = $data[$cur];
		if ($char == '\\' && $data[$cur+1] == 'u') {
			$cur += 2;
			$res .= utf8_encode(chr(hexdec($data[$cur].$data[$cur+1].$data[$cur+2].$data[$cur+3])));
			$cur += 4;
		} else {
			$res .= $char;
			$cur += 1;
		}
	}
	return $res;
}

function uwt_stringtoarray($string){
	$len = strlen($string);
	$cur = 0;
	$characterarray = array();
	while($cur < $len){
		$char = $string{$cur};
		array_push($characterarray,$char);
		$cur = $cur + 1;
	}
	return $characterarray;
}

?>